JUCE: MidiOutput Class Reference

JUCE

Public Member Functions | Static Public Member Functions | List of all members
MidiOutput Class Referencefinal
juce_audio_devices » midi_io

Represents a midi output device. More...

`#include <juce_MidiDevices.h>`

Inheritance diagram for MidiOutput:

## Public Member Functions
| ~MidiOutput () override
| Destructor. More...
MidiDeviceInfo | getDeviceInfo () const noexcept
| Returns the MidiDeviceInfo struct containing some information about this device. More...
String | getIdentifier () const noexcept
| Returns the identifier of this device. More...
String | getName () const noexcept
| Returns the name of this device. More...
void | setName (const String &newName) noexcept
| Sets a custom name for the device. More...
void | sendMessageNow (const MidiMessage &message)
| Sends out a MIDI message immediately. More...
void | sendBlockOfMessagesNow (const MidiBuffer &buffer)
| Sends out a sequence of MIDI messages immediately. More...
void | sendBlockOfMessages (const MidiBuffer &buffer, double millisecondCounterToStartAt, double samplesPerSecondForBuffer)
| This lets you supply a block of messages that will be sent out at some point in the future. More...
void | clearAllPendingMessages ()
| Gets rid of any midi messages that had been added by sendBlockOfMessages(). More...
void | startBackgroundThread ()
| Starts up a background thread so that the device can send blocks of data. More...
void | stopBackgroundThread ()
| Stops the background thread, and clears any pending midi events. More...
bool | isBackgroundThreadRunning () const noexcept
| Returns true if the background thread used to send blocks of data is running. More...

## Static Public Member Functions
static Array< MidiDeviceInfo > | getAvailableDevices ()
| Returns a list of the available midi output devices. More...
static MidiDeviceInfo | getDefaultDevice ()
| Returns the MidiDeviceInfo of the default midi output device to use. More...
static std::unique_ptr< MidiOutput > | openDevice (const String &deviceIdentifier)
| Tries to open one of the midi output devices. More...
static std::unique_ptr< MidiOutput > | createNewDevice (const String &deviceName)
| This will try to create a new midi output device (only available on Linux, macOS and iOS). More...

## Detailed Description

Represents a midi output device.

To create one of these, use the static getAvailableDevices() method to find out what outputs are available, and then use the openDevice() method to try to open one.

See also
  MidiInput

## Constructor & Destructor Documentation

## ◆ ~MidiOutput()

MidiOutput::~MidiOutput | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ getAvailableDevices()

static Array< MidiDeviceInfo > MidiOutput::getAvailableDevices | ( |  | ) |
| static

Returns a list of the available midi output devices.

You can open one of the devices by passing its identifier into the openDevice() method.

See also
  MidiDeviceInfo, getDevices, getDefaultDeviceIndex, openDevice

## ◆ getDefaultDevice()

static MidiDeviceInfo MidiOutput::getDefaultDevice | ( |  | ) |
| static

Returns the MidiDeviceInfo of the default midi output device to use.

## ◆ openDevice()

static std::unique_ptr< MidiOutput > MidiOutput::openDevice | ( | const String & | deviceIdentifier | ) |
| static

Tries to open one of the midi output devices.

This will return a MidiOutput object if it manages to open it, you can then send messages to this device.

If the device can't be opened, this will return an empty object.

Parameters

  deviceIdentifier | the ID of the device to open - use the getAvailableDevices() method to find the available devices that can be opened

See also
  getDevices

## ◆ createNewDevice()

static std::unique_ptr< MidiOutput > MidiOutput::createNewDevice | ( | const String & | deviceName | ) |
| static

This will try to create a new midi output device (only available on Linux, macOS and iOS).

This will attempt to create a new midi output device with the specified name that other apps can connect to and use as their midi input.

NB - if you are calling this method on iOS you must have enabled the "Audio Background Capability" setting in the iOS exporter otherwise this method will fail.

Returns an empty object if a device can't be created.

Parameters

  deviceName | the name of the device to create

## ◆ getDeviceInfo()

MidiDeviceInfo MidiOutput::getDeviceInfo | ( |  | ) | const
| noexcept

Returns the MidiDeviceInfo struct containing some information about this device.

## ◆ getIdentifier()

String MidiOutput::getIdentifier | ( |  | ) | const
| noexcept

Returns the identifier of this device.

## ◆ getName()

String MidiOutput::getName | ( |  | ) | const
| noexcept

Returns the name of this device.

## ◆ setName()

void MidiOutput::setName | ( | const String & | newName | ) |
| noexcept

Sets a custom name for the device.

## ◆ sendMessageNow()

void MidiOutput::sendMessageNow | ( | const MidiMessage & | message | ) |

Sends out a MIDI message immediately.

## ◆ sendBlockOfMessagesNow()

void MidiOutput::sendBlockOfMessagesNow | ( | const MidiBuffer & | buffer | ) |

Sends out a sequence of MIDI messages immediately.

## ◆ sendBlockOfMessages()

void MidiOutput::sendBlockOfMessages | ( | const MidiBuffer & | buffer,
|  | double | millisecondCounterToStartAt,
|  | double | samplesPerSecondForBuffer
| ) |  |

This lets you supply a block of messages that will be sent out at some point in the future.

The MidiOutput class has an internal thread that can send out timestamped messages - this appends a set of messages to its internal buffer, ready for sending.

This will only work if you've already started the thread with startBackgroundThread().

A time is specified, at which the block of messages should be sent. This time uses the same time base as Time::getMillisecondCounter(), and must be in the future.

The samplesPerSecondForBuffer parameter indicates the number of samples per second used by the MidiBuffer. Each event in a MidiBuffer has a sample position, and the samplesPerSecondForBuffer value is needed to convert this sample position to a real time.

## ◆ clearAllPendingMessages()

void MidiOutput::clearAllPendingMessages | ( |  | ) |

Gets rid of any midi messages that had been added by sendBlockOfMessages().

## ◆ startBackgroundThread()

void MidiOutput::startBackgroundThread | ( |  | ) |

Starts up a background thread so that the device can send blocks of data.

Call this to get the device ready, before using sendBlockOfMessages().

## ◆ stopBackgroundThread()

void MidiOutput::stopBackgroundThread | ( |  | ) |

Stops the background thread, and clears any pending midi events.

See also
  startBackgroundThread

## ◆ isBackgroundThreadRunning()

bool MidiOutput::isBackgroundThreadRunning | ( |  | ) | const
| noexcept

Returns true if the background thread used to send blocks of data is running.

See also
  startBackgroundThread, stopBackgroundThread

The documentation for this class was generated from the following file:

- juce_MidiDevices.h